extends base.pug
- load leaflet_tags
- load static

block add_head
  meta(charset='utf-8')
  link(rel='stylesheet' href='https://cdn.jsdelivr.net/gh/openlayers/openlayers.github.io@master/en/v6.14.1/css/ol.css' type='text/css')
  style.
    .map {
    height: 400px;
    width: 100%;
    }
  //script(src='https://cdn.jsdelivr.net/gh/openlayers/openlayers.github.io@master/en/v6.14.1/build/ol.js')
  title OpenLayers Ruta Local
  meta(charset='UTF-8')
  // Openlayers
  link(rel='stylesheet' href='https://openlayers.org/en/latest/css/ol.css')
  script(type='text/javascript' src='https://openlayers.org/en/latest/build/ol.js')
  script(src='https://cdn.polyfill.io/v2/polyfill.min.js?features=requestAnimationFrame,Element.prototype.classList,URL,Object.assign')
  // ol-ext
  link(rel='stylesheet' href='https://cdn.rawgit.com/Viglino/ol-ext/master/dist/ol-ext.min.css')
  script(type='text/javascript' src='https://cdn.rawgit.com/Viglino/ol-ext/master/dist/ol-ext.min.js')


//  {% leaflet_js %}
  {% leaflet_css %}
  meta(content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport")
  style.
    .leaflet-container { height: 100%;}
  script.
    function loadSelectedResult(rid){
      //console.log(url_loc);
      fd = new FormData()
      fd.append("selectedresult", rid );
      fd.append("csrfmiddlewaretoken", '{{ csrf_token }}' );
      document.getElementById("resultados").innerHTML ="<img src='{% static 'icons/loading.gif' %}' alt='cargando...' style='width:48px;height:48px;'>";
      axios.post('{% url "home" %}', fd, {
                headers: {"X-CSRFToken": '{{ csrf_token }}'}
                }).then( (response)=> {
             //console.log(response.data);
             document.getElementById("resultados").innerHTML =response.data;
           }).catch(function (error) {
             console.log(error);
           });
      //console.log('hola!');
    };
    var dataurl = '{% url "data" %}';
    function loadListResults(latlon){
      //console.log(url_loc);
      fd = new FormData()
      fd.append("latlon", latlon );
      fd.append("csrfmiddlewaretoken",  '{{csrf_token}}');
      document.getElementById("resultados").innerHTML ="<img src='{% static 'icons/loading.gif' %}' alt='cargando...' style='width:48px;height:48px;'>";
      axios.post('{% url "home" %}', fd, {
                headers: {"X-CSRFToken":  '{{csrf_token}}'}
                }).then( (response)=> {
             //console.log(response.data);
             document.getElementById("resultados").innerHTML =response.data;
           }).catch(function (error) {
             console.log(error);
           });
      console.log(latlon)
    };
    window.addEventListener("map:init", function (event) {
      var map = event.detail.map;
      // Download GeoJSON data with Ajax
      fetch(dataurl)
      .then(function(resp) {
        return resp.json();
        })
      .then(function(data) {
      var all_Layer = new L.geoJson(data, {
      onEachFeature: function onEachFeature(feature, layer) {
      var props = feature.properties;
      var content = `<div id="${props.id}"><h3>${props.nombre}</h3><br><h4>${props.descripcion}</h4></div>`;//<img width="30" src="${props.picture_url}"/>
      
      layer.bindPopup(content);
      layer.addEventListener('mouseover', function (e) {
            this.openPopup();
        });
        layer.addEventListener('mouseout', function (e) {
            this.closePopup();
        });


      layer.addEventListener("click", function(e) {
        //console.log(e.target.feature.properties)
        loadSelectedResult(e.target.feature.properties.id)
        this.openPopup();

      });

      //console.log(props.tipo_oferta)
      //console.log(this.icon)
      var zoomLevel = map.getZoom();
      //console.log(zoomLevel);
      var x = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
      var y = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
      //console.log(x,y);
        
      icon = {
              iconUrl: 'my-icon.png',
              //iconRetinaUrl: 'my-icon@2x.png',
              iconSize: [x,y],
              iconAnchor: [0, 0],
              popupAnchor: [10, -10],
              //shadowUrl: 'my-icon-shadow.png',
              //shadowRetinaUrl: 'my-icon-shadow@2x.png',
              shadowSize: [68, 95],
              shadowAnchor: [22, 94],
              className: 'puntoicon',

            }; 

      if (props.tipo_oferta === 1) {
        icon.iconUrl = "{% static 'icons/hostal.png' %}"
        icon1 = new L.icon(icon) 
        layer.setIcon(icon1);
      }else{
        icon.iconUrl = "{% static 'icons/cutlery.png' %}"
        icon1 = new L.icon(icon)
        layer.setIcon(icon1);
      };

      }});
      all_Layer.addTo(map);
      
      map.on('zoomend', function() {
        //var currentZoom = map.getZoom();
        
        var i;
        var zoomLevel = map.getZoom();
        //console.log(zoomLevel);
        var x = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
        var y = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
        //console.log(x,y);
        var iconElements = document.getElementsByClassName('puntoicon'); 

        for (i = 0; i < iconElements.length; i++) {
           iconElements[i].style.width = Math.round(x) + 'px';
           iconElements[i].style.height = Math.round(y) + 'px';
        };

        //if (currentZoom > 12) {
        //    all_Layer.eachLayer(function(layer) {
        //        console.log(layer)
        //    });
        //} else {
        //    all_Layer.eachLayer(function(layer) {
        //        console.log(layer.icon);
        //        layer._icon.extend({
        //              options: {
        //                  iconSize:     [38, 95],
        //                  }
        //              });
        //        console.log(layer.icon);
        //        if (layer.feature.properties.num < 0.5)
        //            return layer.setIcon(ar_icon_1_double_size);
        //        else if (layer.feature.properties.num < 1.0)
        //            return layer.setIcon(ar_icon_2_double_size);
        //    });
        //}
      });
      
      });

      var popup = L.popup();
      var theMarker = {};
      function onMapClick(e) {
        //clearPopups(map)

        defaultIcon = new L.icon({
              iconUrl: "{% static 'icons/ask.png' %}",
              //iconRetinaUrl: 'my-icon@2x.png',
              iconSize: [20,20],
              iconAnchor: [20, 0],
              popupAnchor: [0 , 20],
              //shadowUrl: 'my-icon-shadow.png',
              //shadowRetinaUrl: 'my-icon-shadow@2x.png',
              shadowSize: [68, 95],
              shadowAnchor: [22, 94]
            }); 
        if (theMarker != undefined) {
              map.removeLayer(theMarker);
        };
        theMarker = new L.marker(e.latlng,{icon:defaultIcon}).addTo(map);
        loadListResults(e.latlng);
        popup
        .setLatLng(e.latlng)
        .setContent("búsqueda...")// + e.latlng.toString())
        .openOn(map);
        
      }
      map.on('click', onMapClick);
    });


block title
  | Ruta Local

block content
  .grid.grid-cols-12.bg-green-100
    .col-span-12.text-center
      div.content-center.pt-4
        select#zona_select(name='zona_select' onChange="CenterMap(event);")
          {% for z in zonas %}
          option(value='{{ z.id }}' mapzoom="{{z.zoom}}" mapcenter="[{{z.centro.0}},{{z.centro.1}}]") {{ z.nombre }}
          {% endfor %}

    .col-span-12.z-10
      #map.map
        #popup
    .col-span-12.text-center	
      i
        | haga click en el mapa para buscar por cercanía o selecciona un punto

    .col-span-12.content-center
      #resultados
      
  
  script(type='text/javascript').
    //script.
    var xyz = new ol.source.XYZ({
                    url: "{{settings.TILE}}"
                });
    var vectorSource = new ol.source.Vector({
        url: 'http://localhost:8081/wfs/ot/'+
              '?service=WFS&' +
              'version=2.0.0&request=GetFeature&typename=ofertaturistica&'+
              'outputFormat=application/json'
        ,
        format: new ol.format.GeoJSON(),
    });
    const styles =  {               
                0: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/hostal.png' %}",
                                anchor: [0.5, 0.5]
                                })
                              })
                ,
                1: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 0.5],
                                })
                              })
                ,
                2: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 1]
                                })
                              })
                ,
                3: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 1]
                                })
                              }),
                4: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 0.5],
                                })
                              }),
                5: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 1]
                                })
                              }),
                6: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 1]
                                })
                              }),
                7: new ol.style.Style({
                                image: new ol.style.Icon({
                                src: "{% static 'icons/cutlery.png' %}",
                                anchor: [0.5, 1]
                                })
                              }), 
              };
  

    var vectorLayer = new ol.layer.Vector({
            source: vectorSource,
            style: function (feature,resolution,) {
                          //console.log(feature.get("tipo_oferta"));
                          //console.log(resolution);
                          s = styles[feature.get("tipo_oferta")]

                          var actualZoom = this.map.getView().getZoom();
                          var MaxZoom = this.map.getView().getMaxZoom();
                          var MinZoom = this.map.getView().getMinZoom();

                          //console.log(actualZoom);
                          //console.log(MaxZoom);
                          //console.log(MinZoom);

                          s.getImage().setScale(Math.max(0.07*10**(-(MaxZoom-actualZoom)/(MaxZoom-MinZoom)),0.01))
                          //console.log(0.07*10**(-(MaxZoom-actualZoom)/(MaxZoom-MinZoom)));
                          //console.log(0.07-(10**((MaxZoom-actualZoom)/(MaxZoom-MinZoom))-1));
                          //Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)
                          //console.log(zoom);
                          return s;
                        },
                    
              });


    var map = new ol.Map({
                        target: 'map',
                        interactions: ol.interaction.defaults({ altShiftDragRotate:false, pinchRotate:false }),
                        layers: [
                          new ol.layer.Tile({
                            source: xyz,
                            }),
                          this.vectorLayer,
                        ],
                        view: new ol.View({
                          center: ol.proj.fromLonLat({{settings.CENTER}}),
                          zoom: {{settings.ZOOM}},
                          minZoom: 7,
                          maxZoom: 14,
                          })
                        });

    var zonas =  [
                {% for z in zonas %}
                {
                id: {{z.id}},
                zoom: {{z.zoom}},
                centro: [{{z.centro.0}},{{z.centro.1}}],
                descripcion: '{{z.descripcion}}',
                },
                {% endfor%}
            ];
    function CenterMap(zona_id) {
                //console.log("Long: " + long + " Lat: " + lat);
                //var newzona = zonas.filter(m => m.date.toDateString() ===  zona_id);
                var newzona = this.zonas.filter(z => z.id ==  zona_id.target.value)[0];
                map.getView().setCenter(ol.proj.transform(newzona.centro, 'EPSG:4326', 'EPSG:3857'));
                map.getView().setZoom(newzona.zoom);
             };
    
    var select = new ol.interaction.Select({
                  hitTolerance: 5,
                  condition: ol.events.condition.click
                });
    map.addInteraction(select);

    // Popup associated with the select
    var popup = new ol.Overlay.PopupFeature({
      popupClass: 'default anim',
      canFix: true,
      select: select,
    });


    function loadSelectedResult(e){
      //console.log(url_loc);
      var rid = e.feature.A.id;
      this.distancestoallpoints(e.feature);
      fd = new FormData();
      fd.append("selectedresult", rid );
      fd.append("csrfmiddlewaretoken", '{{ csrf_token }}' );
      document.getElementById("resultados").innerHTML ="<img src='{% static 'icons/loading.gif' %}' alt='cargando...' style='width:48px;height:48px;'>";
      axios.post('{% url "home" %}', fd, {
                headers: {"X-CSRFToken": '{{ csrf_token }}'}
                }).then( (response)=> {
             //console.log(response.data);
             document.getElementById("resultados").innerHTML =response.data;
           }).catch(function (error) {
             console.log(error);
           });
      //console.log('hola!');
    };
    var dataurl = '{% url "data" %}';
    function loadListResults(latlon){
      //console.log(url_loc);
      fd = new FormData()
      fd.append("latlon", latlon );
      fd.append("csrfmiddlewaretoken",  '{{csrf_token}}');
      document.getElementById("resultados").innerHTML ="<img src='{% static 'icons/loading.gif' %}' alt='cargando...' style='width:48px;height:48px;'>";
      axios.post('{% url "home" %}', fd, {
                headers: {"X-CSRFToken":  '{{csrf_token}}'}
                }).then( (response)=> {
             //console.log(response.data);
             document.getElementById("resultados").innerHTML =response.data;
           }).catch(function (error) {
             console.log(error);
           });
      console.log(latlon)
    };


    popup.on('select', (e) => loadSelectedResult(e));


    


    map.addOverlay (popup);

    // Reset layer data when too much features in memory
    map.on('moveend', function(e) {
      if (vectorSource.getFeatures().length > 30000) {
        vectorSource.refresh();
      }
      //console.log(vectorSource.getFeatures().length)
    });


    function distanceBetweenPoints(latlng1, latlng2){
            var line = new ol.geom.LineString([latlng1, latlng2]);
            console.log('holi')
            return Math.round(line.getLength() * 100) / 100;
        };
    function distancestoallpoints(feature){
      var feat = vectorSource.getFeatures();
      var base = feature.A.geometry.flatCoordinates
      console.log(feature.A.geometry)
      for (x in feat){
        console.log(x);
        var to = feat[x].A.geometry.flatCoordinates
        console.log(feat[x].A.geometry.flatCoordinates);
        console.log(this.distanceBetweenPoints(base,to));
        //console.log(distanceBetweenPoints())    

      }
    };
    //const element = document.getElementById('popup');
    //
    //const popupOverlay = new ol.Overlay({
    //  element: element,
    //   autoPan: {
    //        animation: {
    //            duration: 250,
    //        },
    //    },
    //  positioning: 'bottom-center',
    //  stopEvent: false,
    //});
    //map.addOverlay(popupOverlay);
    //
    //map.on('click', function(e) {
    //    const pixel = map.getEventPixel(e.originalEvent);
    //    const hit = map.hasFeatureAtPixel(pixel);
    //    if (hit) {
    //        //How to get all features you hover on.
    //        //const featureArray = map.getFeaturesAtPixel(pixel);
    //
    //        popupOverlay.element.hidden = false;
    //        popupOverlay.setPosition(e.coordinate);
    //        console.log('holi');
    //    } else {
    //        popupOverlay.element.hidden = true;
    //        console.log('holu');
    //
    //    }
    //});
    //
    ////map.getView().fit(vectorSource.getExtent(), map.getSize());

    // display popup on click
    //map.on('click', function (evt) {
    //  const feature = map.forEachFeatureAtPixel(evt.pixel, function (feature) {
    //    return feature;
    //  });
    //  if (feature) {
    //    popup.setPosition(evt.coordinate);
    //    $(element).popover({
    //      placement: 'top',
    //      html: true,
    //      content: feature.get('nombre') + ': ' + feature.get('descripcion'),
    //    });
    //    $(element).popover('show');
    //  } else {
    //    $(element).popover('dispose');
    //  }
    //});
    //
    // change mouse cursor when over marker
    //map.on('pointermove', function (e) {
    //  const pixel = map.getEventPixel(e.originalEvent);
    //  const hit = map.hasFeatureAtPixel(pixel);
    //  map.getTarget().style.cursor = hit ? 'pointer' : '';
    //});
    //// Close the popup when the map is moved
    //map.on('movestart', function () {
    //  $(element).popover('dispose');
    //});

